/*
   Copyright (c) 2015 zuendorf 
   
   Permission is hereby granted, free of charge, to any person obtaining a copy of this software 
   and associated documentation files (the "Software"), to deal in the Software without restriction, 
   including without limitation the rights to use, copy, modify, merge, publish, distribute, 
   sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
   furnished to do so, subject to the following conditions: 
   
   The above copyright notice and this permission notice shall be included in all copies or 
   substantial portions of the Software. 
   
   The Software shall be used for Good, not Evil. 
   
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING 
   BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
 */
   
package org.sdmlib.test.examples.simpleModel.model.util;

import java.util.Collection;

import org.sdmlib.test.examples.simpleModel.model.Item;

import de.uniks.networkparser.list.SimpleSet;
import de.uniks.networkparser.interfaces.Condition;

public class ItemSet extends SimpleSet<Item>
{

   public static final ItemSet EMPTY_SET = new ItemSet().withFlag(ItemSet.READONLY);


   public ItemPO hasItemPO()
   {
      return new ItemPO(this.toArray(new Item[this.size()]));
   }

   @SuppressWarnings("unchecked")
   public ItemSet with(Object value)
   {
      if (value instanceof java.util.Collection)
      {
         this.addAll((Collection<Item>)value);
      }
      else if (value != null)
      {
         this.add((Item) value);
      }
      
      return this;
   }
   
   public ItemSet without(Item value)
   {
      this.remove(value);
      return this;
   }

   
   //==========================================================================
   public ItemSet init()
   {
      for (Item obj : this)
      {
         obj.init();
      }
      
      return this;
   }


   public ItemPO filterItemPO()
   {
      return new ItemPO(this.toArray(new Item[this.size()]));
   }


   public String getEntryType()
   {
      return "org.sdmlib.test.examples.simpleModel.model.Item";
   }

   public ItemSet()
   {
      // empty
   }

   public ItemSet(Item... objects)
   {
      for (Item obj : objects)
      {
         this.add(obj);
      }
   }

   public ItemSet(Collection<Item> objects)
   {
      this.addAll(objects);
   }


   public ItemPO createItemPO()
   {
      return new ItemPO(this.toArray(new Item[this.size()]));
   }


   @Override
   public ItemSet getNewList(boolean keyValue)
   {
      return new ItemSet();
   }


   public ItemSet filter(Condition<Item> condition) {
      ItemSet filterList = new ItemSet();
      filterItems(filterList, condition);
      return filterList;
   }}
